
#include "main.h"

#include <shlobj.h>

#include "SafeWrite.h"
#include "FakeDirectDraw.h"
#include "BitmapSaver.h"
#include "TexOverride.h"

//TODO: windowed mode
//TODO: non-exclusive fullscreen mode

DWORD gWidth;
DWORD gHeight;
DWORD UseCompatibleZBuffer;
DWORD UseSysMemOverlay;
DWORD TextOverlayColourKey;
DWORD ForceGammaReset;
DWORD Thief2Extensions;
DWORD AnisotropicFiltering;
DWORD RefreshRate;
static DWORD DisableWinKey;
char TexturePath[128];

static FakeDirectDraw* SavedDirectDraw;

static HHOOK g_hKeyboardHook;

#ifdef CHECKEDBUILD
static HANDLE LogFile;
#endif

//static HANDLE hfile=0;
//static int ccount=0;

static LRESULT CALLBACK LowLevelKeyboardProc( int nCode, WPARAM wParam, LPARAM lParam )
{
    if (nCode < 0 || nCode != HC_ACTION )  // do not process message 
        return CallNextHookEx( g_hKeyboardHook, nCode, wParam, lParam); 
 
    bool bEatKeystroke = false;
    KBDLLHOOKSTRUCT* p = (KBDLLHOOKSTRUCT*)lParam;
    switch (wParam) 
    {
        case WM_KEYDOWN:  
        case WM_KEYUP:    
        {
            bEatKeystroke = (((p->vkCode == VK_LWIN) || (p->vkCode == VK_RWIN)));
            break;
        }
    }
 
    if( bEatKeystroke )
        return 1;
    else
        return CallNextHookEx( g_hKeyboardHook, nCode, wParam, lParam );
}



#ifdef NONEXCLUSIVE
bool _stdcall SetWindowPosHook(HWND, HWND, int, int, int, int, int) { return true; }
bool _stdcall SetWindowLongHook(HWND, int, int) { return true; }
bool _stdcall ShowWindowHook(HWND, int) { return true; }
#endif

bool _stdcall DllMain(HANDLE hDllHandle, DWORD dwReason, LPVOID  lpreserved) {
	if(dwReason==DLL_PROCESS_ATTACH) {

#ifdef NONEXCLUSIVE
		SafeWrite32(0x00600304, (DWORD)SetWindowPosHook);
		SafeWrite32(0x0060025C, (DWORD)SetWindowLongHook);
		SafeWrite32(0x0060028C, (DWORD)ShowWindowHook);
#endif
		if(GetModuleHandle("ddfix.dll")) {
			MessageBox(0, "You seem to be trying to use ddfix 1.3.11 or newer with an exe patched to use 1.3.10 or older.\r\n\r\n"
				"Please use the ddfixGUI to remove the patch, or remove the hexedit by hand.", "Error", MB_OK);
			ExitProcess(1);
		}

		gWidth=GetPrivateProfileInt("Main", "gWidth", 800, ".\\ddfix.ini");
		gHeight=GetPrivateProfileInt("Main", "gHeight", 600, ".\\ddfix.ini");
		UseCompatibleZBuffer=GetPrivateProfileInt("Main", "UseCompatibleZBuffer", 0, ".\\ddfix.ini");
		UseSysMemOverlay=GetPrivateProfileInt("Main", "UseSysMemOverlay", 0, ".\\ddfix.ini");
		TextOverlayColourKey=GetPrivateProfileInt("Main", "OverlayColourKey", 0, ".\\ddfix.ini");
		ForceGammaReset=GetPrivateProfileInt("Main", "ForceGammaReset", 0, ".\\ddfix.ini");
		DisableWinKey=GetPrivateProfileInt("Main", "DisableWindowsKey", 0, ".\\ddfix.ini");
		AnisotropicFiltering=GetPrivateProfileInt("Main", "AnisotropicFiltering", 0, ".\\ddfix.ini");
		RefreshRate=GetPrivateProfileInt("Main", "RefreshRate", 0, ".\\ddfix.ini");
		if(gWidth==640&&gHeight==480) {
			MessageBox(0, "ddfix requires a resolution above 640x480", "Error", MB_OK);
			ExitProcess(1);
		}
		if(!GetPrivateProfileString("Main", "TexturePath", "", TexturePath, 128, ".\\ddfix.ini")) strcpy_s(TexturePath, "res\\ddfix\\");

		FILE* cam=fopen("cam.cfg", "r");
		if(cam) {
			bool match=true;
			char buf[256];
			char* str2;
			char* str3;
			char* str4;
			DWORD count;
			while(fgets(buf,256,cam)) {
				str2=strstr(buf, " ");
				if(!str2) continue;
				str2[0]=0;
				str2++;
				while(str2[0]==' ') str2++;
				str3=strstr(str2, " ");
				if(!str3) continue;
				str3[0]=0;
				str3++;
				while(str3[0]==' ') str3++;
				str4=strstr(str3, " ");
				if(str4) {
					str4[0]=0;
					str4++;
					while(str4[0]==' ') str4++;
					if(str4) continue;
				}
				if(!strcmp(buf, "game_screen_size")) {
					if(atol(str2)!=gWidth||atol(str3)!=gHeight) {
						match=false;
					}
					break;
				}
			}
			fclose(cam);

			if(!match) {
				MessageBox(0, "Resolution in cam.cfg does not match that given in ddfix.ini", "Error", MB_OK);
				ExitProcess(-1);
			}
		}

		if(Thief2Extensions=GetPrivateProfileInt("Main", "Thief2Extensions", 0, ".\\ddfix.ini")) {
			if(Thief2Extensions==1) {
				switch(*(DWORD*)0x005BAA39) {
					case 0x47391875:
						Thief2Extensions=2;
						break;
					default:
						Thief2Extensions=0;
						break;
				}
			}
			switch(Thief2Extensions) {
				case 0:
					break;
				case 2:
					if(*(WORD*)0x005BAA39 != 0x1875 || *(WORD*)0x005BAA3E != 0x1375 || *(DWORD*)0x0041D948!=0xfffffba4) {
						MessageBox(0, "Trying to use thief 2 extensions, but the exe version is incompatible", "Error", MB_OK);
						ExitProcess(-1);
					}
					//Remove check for dodgy drivers
					SafeWrite16(0x005BAA39, 0x9090);
					SafeWrite16(0x005BAA3E, 0x9090);
					//Custom resolutions
					//SafeWrite16(0x67820C, (WORD)gWidth);
					//SafeWrite16(0x67820E, (WORD)gHeight);
					break;
				default:
					ExitProcess(-1);
			}
			if(Thief2Extensions) {
				char buf[MAX_PATH];
				strcpy_s(buf, TexturePath);
				strcat_s(buf, "*");
				WIN32_FIND_DATAA data;
				HANDLE h=FindFirstFileA(buf, &data);
				if(h==INVALID_HANDLE_VALUE) Thief2Extensions=0;
				else {
					FindClose(h);
					OverrideSetup();
				}
			}
		}

		DWORD fix1=0, fix2=0;

		if(GetPrivateProfileInt("Main", "MultiCoreFix", 1, ".\\ddfix.ini")) {
			fix1=1;
			HANDLE process=GetCurrentProcess();
			SetProcessAffinityMask(process, 1);
		}
		if(GetPrivateProfileInt("Main", "VideoFix", 1, ".\\ddfix.ini")) {
			fix2=1;
			PROCESS_INFORMATION p;
			STARTUPINFO s;
			memset(&s, 0, sizeof(STARTUPINFO));
			s.cb=sizeof(STARTUPINFO);
			if(CreateProcessA(0, "regsvr32 /s LGVID.AX", 0, 0, false, 0, 0, 0, &s, &p)) {
				CloseHandle(p.hThread);
				WaitForInputIdle(p.hProcess, 100);
				CloseHandle(p.hProcess);
			}
		}

		if(DisableWinKey) {
			g_hKeyboardHook = SetWindowsHookEx( WH_KEYBOARD_LL,  LowLevelKeyboardProc, GetModuleHandle(NULL), 0 );
		}


#ifdef CHECKEDBUILD
		LogFile=CreateFileA("ddfix-log.txt", GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_FLAG_WRITE_THROUGH, 0);
		DWORD unused;
		char msg[512];
		sprintf_s(msg, "v1.2.1, %dx%d\r\nDuel core fix: %d\r\nVideo fix: %d\r\n\r\n", gWidth, gHeight, fix1, fix2);
		WriteFile(LogFile, msg, strlen(msg), &unused, 0);
#endif
		bmpInit();
	} else if(dwReason==DLL_PROCESS_DETACH) {
		UnhookWindowsHookEx( g_hKeyboardHook );
		SavedDirectDraw->Release();
		bmpExit();
#ifdef CHECKEDBUILD
		CloseHandle(LogFile);
#endif
	}
	return true;
}

#ifdef CHECKEDBUILD
void Log(char* msg) {
	DWORD unused;
	WriteFile(LogFile, msg, strlen(msg), &unused, 0);
}
#endif

typedef HRESULT (_stdcall *DDrawCreateProc)(void* a, void* b, void* c);
typedef HRESULT (_stdcall *DDrawEnumerateProc)(void* callback, void* context);
typedef void (_stdcall *DDrawMiscProc)();
static DDrawCreateProc DDrawCreate=0;
static DDrawEnumerateProc DDrawEnumerate=0;
static DDrawMiscProc AcquireLock;
static DDrawMiscProc ParseUnknown;
static DDrawMiscProc InternalLock;
static DDrawMiscProc InternalUnlock;
static DDrawMiscProc ReleaseLock;

static void LoadDLL() {
	char path[MAX_PATH];
	GetSystemDirectoryA(path,MAX_PATH);
	strcat_s(path, "\\ddraw.dll");
	HMODULE ddrawdll=LoadLibraryA(path);
	DDrawCreate=(DDrawCreateProc)GetProcAddress(ddrawdll, "DirectDrawCreate");
	DDrawEnumerate=(DDrawEnumerateProc)GetProcAddress(ddrawdll, "DirectDrawEnumerateA");

	AcquireLock=(DDrawMiscProc)GetProcAddress(ddrawdll, "AcquireDDThreadLock");
	ParseUnknown=(DDrawMiscProc)GetProcAddress(ddrawdll, "D3DParseUnknownCommand");
	InternalLock=(DDrawMiscProc)GetProcAddress(ddrawdll, "DDInternalLock");
	InternalUnlock=(DDrawMiscProc)GetProcAddress(ddrawdll, "DDInternalUnlock");
	ReleaseLock=(DDrawMiscProc)GetProcAddress(ddrawdll, "ReleaseDDThreadLock");
}

void __declspec(naked) FakeAcquireLock() { 
	_asm jmp AcquireLock;
}
void __declspec(naked) FakeParseUnknown() { 
	_asm jmp ParseUnknown;
}
void __declspec(naked) FakeInternalLock() {
	_asm jmp InternalLock;
}
void __declspec(naked) FakeInternalUnlock() {
	_asm jmp InternalUnlock;
}
void __declspec(naked) FakeReleaseLock() {
	_asm jmp ReleaseLock;
}

HRESULT _stdcall FakeDirectDrawCreate(GUID* a, IDirectDraw** b, IUnknown* c) {
	if(SavedDirectDraw) {
		*b=(IDirectDraw*)SavedDirectDraw;
		SavedDirectDraw->AddRef();
		return 0;
	}
	if(!DDrawCreate) LoadDLL();
	HRESULT hr=DDrawCreate(a,b,c);
	if(FAILED(hr)) return hr;
	SavedDirectDraw=new FakeDirectDraw(*b);
	*b=(IDirectDraw*)SavedDirectDraw;
	SavedDirectDraw->AddRef();
	return 0;
}

HRESULT _stdcall FakeDirectDrawEnumerate(void* lpCallback, void* lpContext) {
	if(!DDrawEnumerate) LoadDLL();
	return DDrawEnumerate(lpCallback, lpContext);
}
